#include "countlines.h"
#include "list.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

istl::cList *FileList = NULL;
int Lines = 0;

clEntry::clEntry(char *File, char *Dir, bool SubDirs)
{
	strcpy(this->File, File);
	strcpy(this->Dir, Dir);
	this->SubDirs = SubDirs;
}

void LoadScript(void)
{
	FILE *f = fopen("countlines.txt", "rt");
	bool withsubfolders = false;
	fseek(f, 0, SEEK_END);
	int size = ftell(f);
	fseek(f, 0, SEEK_SET);
	while(ftell(f)!=size)
	{
		char Line[STRMEM], Both[STRMEM];
		fgets(Line, STRMEM, f);
		Line[strlen(Line)-1] = 0;
		strcpy(Both, Line);
		if(!strcmp(Line, "[withsubfolders]"))
			withsubfolders = true;
		else if(!strcmp(Line, "[withoutsubfolders]"))
			withsubfolders = false;
		else
		{
			char *slash = Line;
			while(strstr(slash, "\\"))
				slash = strstr(slash, "\\") + 1;
			if(slash != Line)
			{
				*(slash-1) = 0;
				(new istl::cList(new clEntry(slash, Line, withsubfolders)))->AddRight(FileList);
			}
			else
			{
				(new istl::cList(new clEntry(Line, ".", withsubfolders)))->AddRight(FileList);
			}
		}
	}
	fclose(f);
}

void CountLines(char *File)
{
	FILE *f = fopen(File, "rt");
	int ThisLines = 0;
	while(!feof(f))
	{
		char Line[STRMEM];
		fgets(Line, STRMEM, f);
		ThisLines++;
	}
	printf("%d Lines\n", ThisLines);
	Lines += ThisLines;
	fclose(f);
}

void Search(char *Dir, char *File, bool Sub)
{
	char Both[STRMEM];
	strcpy(Both, Dir);
	strcat(Both, "\\");
	strcat(Both, File);
	WIN32_FIND_DATA fd;
	HANDLE hdl;
	printf("Searching: %s\n", Both);
	hdl = FindFirstFile(Both, &fd);
	bool more = true;
	while(hdl != INVALID_HANDLE_VALUE && more)
	{
		if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
		{
			// File
			printf("File: %s\n", fd.cFileName);
			char Both[STRMEM];
			strcpy(Both, Dir);
			strcat(Both, "\\");
			strcat(Both, fd.cFileName);
			CountLines(Both);
		}
		more = FindNextFile(hdl, &fd);
	}
	FindClose(hdl);
	strcpy(Both, Dir);
	strcat(Both, "\\");
	strcat(Both, "*.*");
	hdl = FindFirstFile(Both, &fd);
	more = true;
	while(hdl != INVALID_HANDLE_VALUE && more)
	{
		if((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && Sub)
		{
			// Directory
			printf("Directory: %s\n", fd.cFileName);
			if(strcmp(fd.cFileName, ".") && strcmp(fd.cFileName, ".."))
			{
				char New[STRMEM];
				strcpy(New, Dir);
				strcat(New, "\\");
				strcat(New, fd.cFileName);
				printf("Searching SubDirectory: %s\n", New);
				Search(New, File, true);
			}
		}
		more = FindNextFile(hdl, &fd);
	}
	FindClose(hdl);
}

void Count(void)
{
	istl::cList *List = FileList;
	while(List)
	{
		Search(((clEntry *)List->GetData())->Dir, ((clEntry *)List->GetData())->File, ((clEntry *)List->GetData())->SubDirs);
		List = List->GetNext();
	}
}

void CleanUp(void)
{
	FileList->DeleteListWD();
}

int main(void)
{
	LoadScript();
	Count();
	CleanUp();
	printf("insgesamt: %d Zeilen\n", Lines);
	getchar();
	return 0;
}
