#include "list.h"

#include <stdlib.h>

namespace istl
{

cList::cList(void *Data)
{
	this->Data = Data;
	Next = NULL;
}

void cList::AddLeft(cList *&List)
{
	this->Next = List;
	List = this;
}

void cList::AddRight(cList *&List)
{
	if(!List)
	{
		List = this;
	}
	else
	{
		cList *Such = List;
		while(Such->Next) Such = Such->Next;
		Such->Next = this;
	}
}

cList *cList::GetLast(void)
{
	if(this)
	{
		cList *Such = this;
		while(Such->Next) Such = Such->Next;
		return Such;
	}
	else
		return NULL;
}

void cList::DeleteLeftWD(void)
{
	delete Data;
	Data = Next->Data;
	cList *temp = Next;
	Next = temp->Next;
	delete temp;
}

void cList::DeleteListWD(void)
{
	if(this)
	{
		if(Next) Next->DeleteListWD();
		delete Data;
		delete this;
	}
}

cList *cList::GetNext(void)
{
	return Next;
}

void *cList::GetData(void)
{
	return Data;
}

}
